<%@ Import Namespace="System" %>
<%@ Import Namespace="System.IO" %>
<%@ Assembly Name="System.Xml" %>
<%@ Import Namespace="System.NewXml" %>

<script language="C#" runat=server>
public class XmlXPathSample	
{
	private string m_Document = "";
	StringWriter writer;
	
	public string Start(String[] args)
	{
		m_Document = args[0];
		StringWriter writer = new StringWriter();
		Console.SetOut(writer);

        XmlDocument xmldocument = new XmlDocument();
        xmldocument.Load (m_Document);
        DocumentNavigator navigator = new DocumentNavigator(xmldocument);

		// Perform the query
        XPathQuery(navigator, args[1]);

		return writer.ToString();
	}
    private void XPathQuery(XmlNavigator navigator, String xpathexpr )
    {
        try
        {
            // Save context node position
            navigator.PushPosition();
            navigator.Select (xpathexpr);
            FormatXml(navigator);

            // Restore context node position
            navigator.PopPosition();        
        }
        catch (Exception e)
        {
            Console.WriteLine ("Exception: {0}", e.ToString());
        }
    }
    
    private void FormatXml (XmlNavigator navigator)
    {
        while (navigator.MoveToNextSelected())
        {
            switch (navigator.NodeType)
            {
            case XmlNodeType.ProcessingInstruction:
                Format (navigator, "ProcessingInstruction");
                break;
            case XmlNodeType.DocumentType:
                Format (navigator, "DocumentType");
                break;
            case XmlNodeType.Document:
                Format (navigator, "Document");
                break;
            case XmlNodeType.Comment:
                Format (navigator, "Comment");
                break;
            case XmlNodeType.Element:
                Format (navigator, "Element");
                break;
            case XmlNodeType.Text:
                Format (navigator, "Text");
                break;
            case XmlNodeType.Whitespace:
                Format (navigator, "Whitespace");
                break;
            }
        }
        Console.WriteLine();
    }

    // Format the output
    private void Format (XmlNavigator navigator, String NodeType)
    {
        String value = String.Empty;
        String name = String.Empty;

        if (navigator.HasChildren)
        {
            name = navigator.Name;
            navigator.MoveToFirstChild();
            if (navigator.HasValue)
            {
                value = navigator.Value;
            }
        }
        else
        {
            if (navigator.HasValue)
            {
                value = navigator.Value;
                name = navigator.Name;
            }
        }
        Console.WriteLine(NodeType + "<" + name + ">" + value);
    }
} 
</script>
<html>
<head>
      	<link rel="stylesheet" href="intro.css">
</head>

<body style="background-color:f6e4c6">

       	<form action="QueryXmlDocumentXPath.aspx" method="post" runat="server">
       	<font>Input file: </font> 
        <a href="/quickstart/howto/samples/Xml/QueryXmlDocumentXPath/books.xml">books.xml</a>
	<center>
	    &nbsp;&nbsp;<font>XPath Query:</font> <asp:textbox width=200 id="Query" AutoPostBack= "false" Text="descendant::book/price" runat="server"/> 
		&nbsp;&nbsp;<asp:button type=submit text="Query" OnClick="SubmitBtn_Click" runat="server"/>
       	</form>
	</center>		
	<table align="center">
	<tr><th><span>Output From Query...</span></th></tr>
	<tr><th><span></span></th></tr>
	<tr><td><h4><xmp id="output" runat="server"/></h4></td></tr>
	</table>

</body>
</html>

<script language="C#" runat=server>

private void SubmitBtn_Click(Object sender, EventArgs e)
{
	string query = Query.Text;
		
	String[] args = {Server.MapPath("books.xml"), query};

	XmlXPathSample myXmlXPathSample= new XmlXPathSample();
	output.InnerHtml = myXmlXPathSample.Start(args);
}
</script>
