<%@ Import Namespace="System" %>
<%@ Import Namespace="System.IO" %>
<%@ Assembly Name="System.Xml" %>
<%@ Import Namespace="System.NewXml" %>
<%@ Import Namespace="System.NewXml.Xsl" %>

<script language="C#" runat=server>
public class XmlDocumentSample
{
	private string m_Document = "";
    private string m_Stylesheet = "";
	StringWriter writer;
	
	public string Start(String[] args)
	{
		m_Document = args[0];
		m_Stylesheet = args[1];
		StringWriter writer = new StringWriter();
		Console.SetOut(writer);

        XmlReader docreader = null;

        try
        {
            // Load the XML from file
            Console.WriteLine ("Loading file {0} ...", m_Document);

            XmlDataDocument xmldocument = new XmlDataDocument();
            xmldocument.Load (m_Document);

            Console.WriteLine ("XmlDataDocument loaded with XML data successfully ...\r\n");

            // The use of an XslTransform is a work-around for getting an XmlReader from XmlDataDocument
            // until DataDocumentReader is implemented.
            // DataDocumentReader docreader = DataDocumentReader(xmldocument);

            Console.WriteLine ("Reading XML ...\r\n");

            XslTransform   xsltransform = new XslTransform();
            xsltransform.Load(m_Stylesheet);
            docreader = xsltransform.Transform(new DataDocumentNavigator(xmldocument), null);
            FormatXml (docreader);
        }

        catch (Exception e)
        {
            Console.WriteLine ("Exception: {0}", e.ToString());
        }

        finally
        {
            // Close the reader
            if (docreader != null)
                docreader.Close();
        }

		return writer.ToString();
	}

    private static void FormatXml (XmlReader reader)
    {
        while (reader.Read())
        {
            switch (reader.NodeType)
            {
            case XmlNodeType.ProcessingInstruction:
                Format (reader, "ProcessingInstruction");
                break;
            case XmlNodeType.DocumentType:
                Format (reader, "DocumentType");
                break;
            case XmlNodeType.Document:
                Format (reader, "Document");
                break;
            case XmlNodeType.Comment:
                Format (reader, "Comment");
                break;
            case XmlNodeType.Element:
                Format (reader, "Element");
				while(reader.MoveToNextAttribute())
                {
                    Format (reader, "Attribute");
				}
                break;
            case XmlNodeType.Text:
                Format (reader, "Text");
                break;
            case XmlNodeType.Whitespace:
                Format (reader, "Whitespace");
                break;
            }
        }
    }

    // Format the output
    private static void Format(XmlReader reader, String NodeType)
    {
        // Format the output
        Console.Write(reader.Depth + " ");
        Console.Write(reader.AttributeCount + " ");
        for (int i=0; i < reader.Depth; i++)
        { 
            Console.Write('\t');
        }

        Console.Write(NodeType + "<" + reader.Name + ">" + reader.Value);
        Console.WriteLine();
    }
} 
</script>
<html>
<head>
      	<link rel="stylesheet" href="intro.css">
</head>
<body style="background-color:f6e4c6">

       	<form action="StreamXmlDocument.aspx" method="post" runat="server">
       	<font>Input file: </font> 
        <a href="/quickstart/howto/samples/Xml/StreamXmlDocument/books.xml">books.xml</a>
       	&nbsp;&nbsp;<font>Stylesheet: </font> 
        <a href="/quickstart/howto/samples/Xml/StreamXmlDocument/identity.xsl">identity.xsl</a>
	<center>
		&nbsp;&nbsp;&nbsp;&nbsp;<asp:button type=submit text="Run" OnClick="SubmitBtn_Click" runat="server"/></br>
       	</form>
	</center>
	<table align="center">
	<tr><th><span>Output from reading file...</span></th></tr>
	<tr><th><span></span></th></tr>
	<tr><td><h4><xmp id="output" runat="server"/></h4></td></tr>
	</table>

</body>
</html>

<script language="C#" runat=server>

private void SubmitBtn_Click(Object sender, EventArgs e)
{
    string[] args ={Server.MapPath("books.xml"),Server.MapPath("identity.xsl")};

	XmlDocumentSample myXmlDocumentSample= new XmlDocumentSample();
	output.InnerHtml = myXmlDocumentSample.Start(args);
}
</script>
